#include <stdlib.h>
#include <stdio.h>

// legge n da input e genera un array A di n elementi pos e negativi in [-1000, 1000] poi risolve il problema

#define RANGE (1000) 

/* Soluzione lineare del problema. Consultare il libro di testo. 
   *l e *r memorizzeranno l'estremo sinistro e destro del segmento di somma massima.
*/

void sumMax(int a[], int n, int *l, int *r) {

  int i, j, somma = -1, max = a[0]; 
  
  *l = *r = 0;
  for ( j = 0; j < n; j++ ) {
      if ( somma <=  0 ) { // non è conveniente estendere
	   i = j; 
	   somma = a[j]; 
      } else somma += a[j]; // è conveniente estendere

      // qui somma memorizza la somma a[i...j]
      if ( somma > max ) { // il segmento è il massimo corrente
	  max = somma;
	  *l = i; 
	  *r = j;	
      }
   }
}


int main() {
  
  int i, n, *a, l, r; 

  scanf("%d", &n);
  if( n <= 0 ) return 1;
    
  a = (int *) malloc(n * sizeof(int));
  if ( a == NULL ) return 1;
  
  srand( time( NULL ) );
  for (i = 0; i < n; i++) 
      a[i] = (rand() % (RANGE*2+1)) - RANGE; // genera un numero casuale in [-RANGE, RANGE]

  sumMax(a, n, &l, &r);

  printf("%d %d\n", l , r);
  return 0;

}